"use strict";
/**
 * Created By: Sumit Kanchan
 * Created on: 1 May 2017
 * Modified By: Sumit Kanchan
 * Modified on: 28 Feb 2020
 * Description: This class will contain only the core methods required for the SPOperations
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SPBase = void 0;
var sp_http_1 = require("@microsoft/sp-http");
var SPCore_1 = require("./SPCore");
var sp_core_library_1 = require("@microsoft/sp-core-library");
var CLASS_NAME = 'SPBase';
/**
 * This file contains the base methods required to make any SharePoint operations.
 * All core interaction methods needs to be placed in this file and then to be used.
 * This class implements singleton, so only single instance is created, remember when introducing any new method.
 * Prevent using directly these methods in the webparts.
 */
var SPBase = /** @class */ (function () {
    function SPBase(spHttpClient, webUrl, logSource) {
        this.logSource = "SPFXHelper";
        this.spHttpClient = spHttpClient;
        this.webURL = webUrl;
        this.logSource = logSource;
    }
    Object.defineProperty(SPBase.prototype, "WebUrl", {
        /** return the web url */
        get: function () {
            return this.webURL;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SPBase.prototype, "LogSource", {
        /** return the web url */
        get: function () {
            return this.logSource;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Call this method to execute GET query.
     * Returns ISPBaseResponse object with the response of the query
    */
    SPBase.prototype.spQueryGET = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var result, respObj, options, response, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, 4, 5]);
                        options = {
                            headers: {
                                'Accept': 'application/json',
                                'odata-version': ''
                            }
                        };
                        return [4 /*yield*/, this.spHttpClient.get(query, sp_http_1.SPHttpClient.configurations.v1, options)];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, response.json()];
                    case 2:
                        respObj = _a.sent();
                        if (response.ok) {
                            result = { error: undefined, ok: true, result: respObj };
                        }
                        else {
                            result = { error: new Error("" + respObj["odata.error"]["message"]["value"]), ok: false, result: undefined };
                            sp_core_library_1.Log.error(this.logSource, new Error("Error occured in SPHelperBase.spQueryGET"));
                            sp_core_library_1.Log.error(this.LogSource, result.error);
                        }
                        return [3 /*break*/, 5];
                    case 3:
                        error_1 = _a.sent();
                        sp_core_library_1.Log.error(this.logSource, new Error("Error occured in SPHelperBase.spQueryGET"));
                        sp_core_library_1.Log.error(this.logSource, new Error("Query: " + query));
                        sp_core_library_1.Log.error(this.logSource, error_1);
                        result = { error: error_1, ok: false, result: undefined };
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, Promise.resolve(result)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Call this method to execute POST query.
     * Returns the response on the execution of the query
    */
    SPBase.prototype.spQueryPOST = function (postProps) {
        return __awaiter(this, void 0, void 0, function () {
            var result, options, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, 3, 4]);
                        options = { headers: { 'odata-version': '3.0' } };
                        if (!SPCore_1.SPCore.isEmptyString(postProps.body)) {
                            options["body"] = postProps.body;
                        }
                        return [4 /*yield*/, this.executePOSTRequest(postProps.url, options)];
                    case 1:
                        result = _a.sent();
                        return [3 /*break*/, 4];
                    case 2:
                        error_2 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".spQueryPOST"));
                        sp_core_library_1.Log.error(this.LogSource, error_2);
                        result = { ok: false, error: error_2, result: undefined };
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, result];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
    * Call this method to execute MERGE query.
    * Returns ISPBaseResponse object with the response of the query
   */
    SPBase.prototype.spQueryMERGE = function (postProps) {
        return __awaiter(this, void 0, void 0, function () {
            var result, options, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, 3, 4]);
                        options = {};
                        if (!SPCore_1.SPCore.isEmptyString(postProps.body)) {
                            options = {
                                headers: {
                                    'Accept': 'application/json;odata=nometadata',
                                    'Content-type': 'application/json;odata=verbose',
                                    'odata-version': '',
                                    'IF-MATCH': '*',
                                    'X-HTTP-Method': 'MERGE'
                                },
                                body: postProps.body
                            };
                        }
                        else {
                            options = {
                                headers: { 'odata-version': '3.0' },
                            };
                        }
                        return [4 /*yield*/, this.executePOSTRequest(postProps.url, options)];
                    case 1:
                        result = _a.sent();
                        return [3 /*break*/, 4];
                    case 2:
                        error_3 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".spQueryMERGE"));
                        sp_core_library_1.Log.error(this.LogSource, error_3);
                        result = { ok: false, error: error_3, result: undefined };
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, result];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Call this method to execute PATCH query.
     * Returns ISPBaseResponse object with the response of the query
    */
    SPBase.prototype.spQueryPATCH = function (postProps) {
        return __awaiter(this, void 0, void 0, function () {
            var result, options, error_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, 3, 4]);
                        options = {};
                        if (!SPCore_1.SPCore.isEmptyString(postProps.body)) {
                            options = {
                                headers: {
                                    'Accept': 'application/json;odata=nometadata',
                                    'Content-type': 'application/json;odata=verbose',
                                    'odata-version': '',
                                    'IF-MATCH': '*',
                                    'X-HTTP-Method': 'PATCH'
                                },
                                body: postProps.body
                            };
                        }
                        else {
                            options = {
                                headers: { 'odata-version': '3.0' },
                            };
                        }
                        return [4 /*yield*/, this.executePOSTRequest(postProps.url, options)];
                    case 1:
                        result = _a.sent();
                        return [3 /*break*/, 4];
                    case 2:
                        error_4 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".spQueryPATCH"));
                        sp_core_library_1.Log.error(this.LogSource, error_4);
                        result = { ok: false, error: error_4, result: undefined };
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, result];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Executes the request for the POST/MERGE/PATCH
     */
    SPBase.prototype.executePOSTRequest = function (url, options) {
        return __awaiter(this, void 0, void 0, function () {
            var result, response, respObj, error_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, 4, 5]);
                        return [4 /*yield*/, this.spHttpClient.post(url, sp_http_1.SPHttpClient.configurations.v1, options)];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, response.json()];
                    case 2:
                        respObj = _a.sent();
                        if (response.ok) {
                            result = { ok: true, result: respObj, error: undefined };
                        }
                        else {
                            result = { ok: false, error: new Error("" + respObj["odata.error"]["message"]["value"]), result: undefined };
                            sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".executePOSTRequest"));
                            sp_core_library_1.Log.error(this.LogSource, result.error);
                        }
                        return [3 /*break*/, 5];
                    case 3:
                        error_5 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".executePOSTRequest"));
                        sp_core_library_1.Log.error(this.LogSource, error_5);
                        result = { ok: false, error: error_5, result: undefined };
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, result];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return SPBase;
}());
exports.SPBase = SPBase;
