"use strict";
/**
 * Created By: Sumit Kanchan
 * Created on: 1 May 2017
 * Modified By: Sumit Kanchan
 * Modified on: 28 feb 2020
 * Description: This class will contain only the miscrelaneous methods required for the SPOperations
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SPCommonOperations = void 0;
var SPBase_1 = require("./SPBase");
var sp_core_library_1 = require("@microsoft/sp-core-library");
var CLASS_NAME = "SPCommonOperations";
/**
 * This class will contain only the miscrelaneous methods required for the SPOperations
 */
var SPCommonOperations = /** @class */ (function (_super) {
    __extends(SPCommonOperations, _super);
    function SPCommonOperations(spHttpClient, webUrl, logSource) {
        return _super.call(this, spHttpClient, webUrl, logSource) || this;
    }
    /** Use this method to get the SPCommonOperations class Object */
    SPCommonOperations.getInstance = function (spHttpClient, webUrl, logSource) {
        return new SPCommonOperations(spHttpClient, webUrl, logSource);
    };
    /**
    * Method returns the SharePoint default icons for each file type
    * @param fileNames : array of file names for which icons are required
    */
    SPCommonOperations.prototype.getDocIconByFiles = function (fileNames) {
        return __awaiter(this, void 0, void 0, function () {
            var extensions, docDetails, requests_1, responses_1, error_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        extensions = [];
                        docDetails = [];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        // Get all the unique file extensions to redudce the number of calls
                        fileNames.forEach(function (i) {
                            var ext = i.slice(i.lastIndexOf('.'));
                            if (extensions.indexOf(ext) == -1) {
                                extensions.push(ext);
                            }
                        });
                        requests_1 = [];
                        extensions.forEach(function (i) {
                            var url = _this.WebUrl + "/_api/web/maptoicon(filename='abc" + i + "', progid='', size='3')";
                            requests_1.push(_this.spQueryGET(url));
                        });
                        return [4 /*yield*/, Promise.all(requests_1)];
                    case 2:
                        responses_1 = _a.sent();
                        fileNames.forEach(function (file) {
                            // check the extension of the file
                            var ext = file.slice(file.lastIndexOf('.'));
                            // get the index of the same in the extension array
                            var index = extensions.indexOf(ext);
                            // response object for the current file
                            var response = responses_1[index];
                            // create the response object
                            docDetails.push({ error: response.error, fileName: file, imageUrl: response.error ? undefined : "/_layouts/15/images/" + response.result.value, ok: response.ok });
                        });
                        return [3 /*break*/, 5];
                    case 3:
                        error_1 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getDocIconByFiles"));
                        sp_core_library_1.Log.error(this.LogSource, error_1);
                        docDetails = [{ error: error_1, imageUrl: undefined, fileName: undefined, ok: false }];
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, Promise.resolve(docDetails)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
    * Method gives access to query GET
    * @param url : query URL
    */
    SPCommonOperations.prototype.queryGETResquest = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.spQueryGET(url)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Method gives access to query POST
     * @param postProps : ISPPostRequest object
     */
    SPCommonOperations.prototype.queryPOSTRequest = function (postProps) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.spQueryPOST(postProps)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Method gives access to query MERGE
     * @param postProps : ISPPostRequest object
     */
    SPCommonOperations.prototype.queryMERGERequest = function (postProps) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.spQueryMERGE(postProps)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Method gives access to query PATCH
     * @param postProps : ISPPostRequest object
     */
    SPCommonOperations.prototype.queryPATCHRequest = function (postProps) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.spQueryPATCH(postProps)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return SPCommonOperations;
}(SPBase_1.SPBase));
exports.SPCommonOperations = SPCommonOperations;
