"use strict";
/**
 * Created By: Sumit Kanchan
 * Created on: 1 May 2017
 * Modified By: Sumit Kanchan
 * Modified on: 1 May 2017
 * Description: This class will contain only the SPField specific methods
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SPFieldOperations = void 0;
var SPBase_1 = require("./SPBase");
var SPCore_1 = require("./SPCore");
var ISPFieldProps_1 = require("./Props/ISPFieldProps");
var sp_core_library_1 = require("@microsoft/sp-core-library");
var CLASS_NAME = "SPFieldOperations";
/**
 * This class will contain only the SPField specific methods
 */
var SPFieldOperations = /** @class */ (function (_super) {
    __extends(SPFieldOperations, _super);
    function SPFieldOperations(spHttpClient, webUrl, logSource) {
        return _super.call(this, spHttpClient, webUrl, logSource) || this;
    }
    /** Use this method to get the SPFieldOperations class Object */
    SPFieldOperations.getInstance = function (spHttpClient, webUrl, logSource) {
        return new SPFieldOperations(spHttpClient, webUrl, logSource);
    };
    /**
     * Method adds respective Field in respective View of respective List
     * @param listTitle : Title of the list in which view exists
     * @param viewName : Name of the view
     * @param fieldName : internal name of the field
     */
    SPFieldOperations.prototype.addFieldToView = function (listTitle, viewName, fieldName) {
        return __awaiter(this, void 0, void 0, function () {
            var result, isAdded, url, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, 5, 6]);
                        return [4 /*yield*/, this.isFieldInView(listTitle, viewName, fieldName)];
                    case 1:
                        isAdded = _a.sent();
                        if (!!isAdded) return [3 /*break*/, 3];
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/views/getByTitle('" + viewName + "')/ViewFields/addviewfield('" + fieldName + "')";
                        return [4 /*yield*/, this.spQueryPOST({ body: undefined, url: url })];
                    case 2:
                        result = _a.sent();
                        _a.label = 3;
                    case 3: return [3 /*break*/, 6];
                    case 4:
                        error_1 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".addFieldToView"));
                        sp_core_library_1.Log.error(this.LogSource, error_1);
                        result = { ok: false, error: error_1 };
                        return [3 /*break*/, 6];
                    case 5: return [2 /*return*/, Promise.resolve(result)];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method checks if the respective Field is the part of the respective View in respective List
     * @param listTitle : Title of the list in which view exists
     * @param viewName : Name of the view
     * @param fieldName : Internal Name of the field
     */
    SPFieldOperations.prototype.isFieldInView = function (listTitle, viewName, fieldName) {
        return __awaiter(this, void 0, void 0, function () {
            var result, response, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = false;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        return [4 /*yield*/, this.getFieldsByView(listTitle, viewName)];
                    case 2:
                        response = _a.sent();
                        if (response.ok) {
                            result = response.result.Items.indexOf(fieldName) > -1;
                        }
                        return [3 /*break*/, 5];
                    case 3:
                        error_2 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".isFieldInView"));
                        sp_core_library_1.Log.error(this.LogSource, error_2);
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, Promise.resolve(result)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Returns all the fiedls associated with the view
     * @param listTitle : title of the list
     * @param viewName : title of the view
     * @returns All fields schema
     * @returns Array of all the field Internal Name
     */
    SPFieldOperations.prototype.getFieldsByView = function (listTitle, viewName) {
        return __awaiter(this, void 0, void 0, function () {
            var result, url, response, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = { ok: false };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/views/getByTitle('" + viewName + "')/ViewFields/";
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 2:
                        response = _a.sent();
                        result = { ok: response.ok, details: response.result, error: response.error };
                        return [3 /*break*/, 5];
                    case 3:
                        error_3 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getFieldsByView"));
                        sp_core_library_1.Log.error(this.LogSource, error_3);
                        result = { ok: false, error: error_3 };
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, Promise.resolve(result)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
    * Returns all the fiedls associated with the list
    * @param listTitle : title of the list
    */
    SPFieldOperations.prototype.getFieldsByList = function (listTitle) {
        return __awaiter(this, void 0, void 0, function () {
            var result, url, response, error_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, 3, 4]);
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/fields/";
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 1:
                        response = _a.sent();
                        result = { details: !!response.result.value ? response.result.value : response.result, ok: response.ok, error: response.error };
                        return [3 /*break*/, 4];
                    case 2:
                        error_4 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getFieldsByList"));
                        sp_core_library_1.Log.error(this.LogSource, error_4);
                        result = { ok: false, error: error_4 };
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, Promise.resolve(result)];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method checks if the Field exists in the List.
     * If it exists then returns the details of the field
     * @param fieldTitle : Title of the Field
     * @param listName : Title of the list
     */
    SPFieldOperations.prototype.getFieldByList = function (fieldTitle, listName) {
        return __awaiter(this, void 0, void 0, function () {
            var result, url, response, error_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, 3, 4]);
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + listName + "')/fields?&$filter=Title eq '" + fieldTitle + "'";
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 1:
                        response = _a.sent();
                        if (response.ok && !!response.result.value && response.result.value.length > 0) {
                            result = { ok: true, detail: response.result.value[0], error: undefined };
                        }
                        else {
                            // Check if any error occured or the field does not found
                            result = { ok: response.ok, error: response.ok ? new Error("Could not find the field with the specified title '" + fieldTitle + "' in the list") : response.error };
                        }
                        return [3 /*break*/, 4];
                    case 2:
                        error_5 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getFieldByList"));
                        sp_core_library_1.Log.error(this.LogSource, error_5);
                        result = { ok: false, error: error_5 };
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, Promise.resolve(result)];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method adds the Site column to the List.
     * @param fieldTitle : Title of the field
     * @param listTitle : Title of the list
     * @param fieldSchemaXML : Schema Xml of the field
     */
    SPFieldOperations.prototype.addSiteColumnToList = function (fieldTitle, listTitle) {
        return __awaiter(this, void 0, void 0, function () {
            var result, field, url, data, response, error_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, 5, 6]);
                        return [4 /*yield*/, this.getFieldBySite(fieldTitle)];
                    case 1:
                        field = _a.sent();
                        if (!field.ok) return [3 /*break*/, 3];
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/fields/createfieldasxml";
                        data = JSON.stringify({
                            "parameters": {
                                "__metadata": { "type": "SP.XmlSchemaFieldCreationInformation" },
                                "Options": 8,
                                "SchemaXml": field.detail.SchemaXml
                            }
                        });
                        return [4 /*yield*/, this.spQueryPOST({ body: data, url: url })];
                    case 2:
                        response = _a.sent();
                        result = { ok: response.ok, error: response.error, detail: response.result };
                        _a.label = 3;
                    case 3: return [3 /*break*/, 6];
                    case 4:
                        error_6 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".addSiteColumnToList"));
                        sp_core_library_1.Log.error(this.LogSource, error_6);
                        result = { ok: false, error: error_6, detail: undefined };
                        return [3 /*break*/, 6];
                    case 5: return [2 /*return*/, Promise.resolve(result)];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method creates the Site column
     * @param field : IFieldPost object to retrieve the information required
     */
    SPFieldOperations.prototype.createSiteColumn = function (field) {
        return __awaiter(this, void 0, void 0, function () {
            var result, postUrl, response, error_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, 3, 4]);
                        postUrl = this.WebUrl + "/_api/web/fields/" + (field.fieldType == ISPFieldProps_1.FieldType.Lookup ? 'addfield' : '');
                        return [4 /*yield*/, this.spQueryPOST({ body: this.getColumnMetadata(field, ISPFieldProps_1.FieldScope.SiteColumn), url: postUrl })];
                    case 1:
                        response = _a.sent();
                        result = { ok: response.ok, error: response.error, detail: response.result };
                        return [3 /*break*/, 4];
                    case 2:
                        error_7 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".createSiteColumn"));
                        sp_core_library_1.Log.error(this.LogSource, error_7);
                        result = { ok: false, error: error_7 };
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, Promise.resolve(result)];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Checks if the fiels exists in site and returns with data
     * @param fieldTitle :Title of the field
     */
    SPFieldOperations.prototype.getFieldBySite = function (fieldTitle) {
        return __awaiter(this, void 0, void 0, function () {
            var result, url, response, error_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, 3, 4]);
                        url = this.WebUrl + "/_api/web/fields?$filter=Title eq '" + fieldTitle + "'";
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 1:
                        response = _a.sent();
                        if (response.ok && !!response.result.value && response.result.value.length > 0) {
                            result = { ok: true, detail: response.result.value[0], error: undefined };
                        }
                        else {
                            // Check if any error occured or the field does not found
                            result = { ok: response.ok, error: response.ok ? new Error("Could not find the field with the specified title '" + fieldTitle + "' in the site") : response.error };
                        }
                        return [3 /*break*/, 4];
                    case 2:
                        error_8 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getFieldBySite"));
                        sp_core_library_1.Log.error(this.LogSource, error_8);
                        result = { ok: false, error: error_8 };
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, Promise.resolve(result)];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method returns the metadata of the solumn based on the IFieldPOST object
     * */
    SPFieldOperations.prototype.getColumnMetadata = function (fieldDetails, fieldScope) {
        var metadata;
        fieldDetails.allowMultiValues = SPCore_1.SPCore.isNull(fieldDetails.allowMultiValues) ? false : fieldDetails.allowMultiValues;
        switch (fieldDetails.fieldType) {
            case ISPFieldProps_1.FieldType.MultiChoice:
                var multiChoices = "'" + fieldDetails.choices.join("','") + "'";
                fieldDetails.defaultValue = SPCore_1.SPCore.isEmptyString(fieldDetails.defaultValue) ? fieldDetails.choices[0] : fieldDetails.defaultValue;
                metadata = "{ '__metadata': { 'type': 'SP.FieldMultiChoice' }, 'FieldTypeKind': 15, 'DefaultValue': '" + fieldDetails.defaultValue + "', {COLUMNGROUP}, 'Required': " + fieldDetails.isRequired + ", 'Title': '" + fieldDetails.title + "', 'Choices': { '__metadata': { 'type': 'Collection(Edm.String)' }, 'results': [" + multiChoices + "] }, 'EditFormat': 0 }";
                break;
            case ISPFieldProps_1.FieldType.Choice:
                var choices = "'" + fieldDetails.choices.join("','") + "'";
                fieldDetails.defaultValue = SPCore_1.SPCore.isEmptyString(fieldDetails.defaultValue) ? fieldDetails.choices[0] : fieldDetails.defaultValue;
                metadata = "{ '__metadata': { 'type': 'SP.FieldChoice' }, 'FieldTypeKind': 6, 'DefaultValue': '" + fieldDetails.defaultValue + "', {COLUMNGROUP} 'Required':  " + fieldDetails.isRequired + ", 'Title': '" + fieldDetails.title + "', 'Choices': { '__metadata': { 'type': 'Collection(Edm.String)' }, 'results': [" + choices + "] }, 'EditFormat': 0 }";
                break;
            case ISPFieldProps_1.FieldType.Number:
                metadata = "{ '__metadata': { 'type': 'SP.FieldNumber' }, 'FieldTypeKind': 9, {COLUMNGROUP} 'Required':  " + fieldDetails.isRequired + ", 'Title': '" + fieldDetails.title + "'";
                break;
            case ISPFieldProps_1.FieldType.Lookup:
                metadata = "{ 'parameters': { '__metadata': { 'type': 'SP.FieldCreationInformation' }, 'FieldTypeKind': 7, {COLUMNGROUP} 'Required':  " + fieldDetails.isRequired + ", 'Title': '" + fieldDetails.title + "', 'LookupListId': '" + fieldDetails.lookupListID + "', 'LookupFieldName': '" + fieldDetails.lookupColName + "' }}";
                break;
            case ISPFieldProps_1.FieldType.Note:
                metadata = "{ '__metadata': { 'type': 'SP.FieldMultiLineText' }, 'FieldTypeKind': 3,{COLUMNGROUP} 'Required':  " + fieldDetails.isRequired + ", 'Title': '" + fieldDetails.title + "', 'NumberOfLines': 12, 'RichText': true, 'AllowHyperlink' : true, 'RestrictedMode': true}";
                break;
            case ISPFieldProps_1.FieldType.Text:
                metadata = "{ '__metadata': { 'type': 'SP.Field' }, 'FieldTypeKind': 2, {COLUMNGROUP} 'Required':  " + fieldDetails.isRequired + ", 'Title': '" + fieldDetails.title + "'}";
                break;
            case ISPFieldProps_1.FieldType.User:
                metadata = "{ '__metadata': { 'type': 'SP.FieldUser' }, 'FieldTypeKind': 20, {COLUMNGROUP} 'Required':  " + fieldDetails.isRequired + ", 'Title': '" + fieldDetails.title + "', 'SelectionMode': 0, 'Presence': true}";
                break;
            case ISPFieldProps_1.FieldType.Boolean:
                break;
            case ISPFieldProps_1.FieldType.DateTime:
                break;
        }
        metadata = fieldScope == ISPFieldProps_1.FieldScope.ListColumn ? metadata.replace('{COLUMNGROUP}', '') : metadata.replace('{COLUMNGROUP}', "'Group': '" + fieldDetails.group + "',");
        return metadata;
    };
    /**
     * Method creates the column to the list
     * @param field : IFieldPOST object to retrieve required information
     */
    SPFieldOperations.prototype.createListColumn = function (field) {
        return __awaiter(this, void 0, void 0, function () {
            var result, postUrl, response, error_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, 5, 6]);
                        postUrl = this.WebUrl + "/_api/web/lists/getByTitle('" + field.listName + "')/fields/" + (field.fieldType == ISPFieldProps_1.FieldType.Lookup ? 'addfield' : '');
                        return [4 /*yield*/, this.spQueryPOST({ body: this.getColumnMetadata(field, ISPFieldProps_1.FieldScope.ListColumn), url: postUrl })];
                    case 1:
                        response = _a.sent();
                        if (!(field.addToView && !SPCore_1.SPCore.isEmptyString(field.viewName) && !SPCore_1.SPCore.isEmptyString(field.listName))) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.addFieldToView(field.listName, field.viewName, response.result.InternalName)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        result = { ok: response.ok, error: response.error, detail: response.result };
                        return [3 /*break*/, 6];
                    case 4:
                        error_9 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".createListColumn"));
                        sp_core_library_1.Log.error(this.LogSource, error_9);
                        result = { ok: false, error: error_9 };
                        return [3 /*break*/, 6];
                    case 5: return [2 /*return*/, Promise.resolve(result)];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    return SPFieldOperations;
}(SPBase_1.SPBase));
exports.SPFieldOperations = SPFieldOperations;
