"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SPListOperations = void 0;
var SPBase_1 = require("./SPBase");
var sp_core_library_1 = require("@microsoft/sp-core-library");
var SPCore_1 = require("./SPCore");
var CLASS_NAME = "SPListOperations";
// const CLASS_NAME: string = `SPListOperations`;
/**
 * This class will contain only the List-Library specific methods required for the SPOperations
 */
var SPListOperations = /** @class */ (function (_super) {
    __extends(SPListOperations, _super);
    function SPListOperations(spHttpClient, webUrl, logSource) {
        return _super.call(this, spHttpClient, webUrl, logSource) || this;
    }
    /** Use this method to get the SPListOperations class Object */
    SPListOperations.getInstance = function (spHttpClient, webUrl, logSource) {
        return new SPListOperations(spHttpClient, webUrl, logSource);
    };
    /**
     * Method returns the list details if exists.
     * Check property exists to check if list exists or not.
     * This will check the list existence only in current web.
     * @param lstTitle : Provide the title of the list
     */
    SPListOperations.prototype.getListByTitle = function (lstTitle) {
        return __awaiter(this, void 0, void 0, function () {
            var result, query, response, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // if list title is blank, return with error
                        if (SPCore_1.SPCore.isEmptyString(lstTitle)) {
                            return [2 /*return*/, Promise.resolve({ exists: false, ok: false, error: new Error("List Title cannot be blank") })];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        query = this.WebUrl + "/_api/web/lists/getByTitle('" + lstTitle + "')";
                        return [4 /*yield*/, this.spQueryGET(query)];
                    case 2:
                        response = _a.sent();
                        if (response.ok) {
                            result = { exists: !!response.result, ok: true, details: response.result };
                        }
                        else {
                            // Set ok,error if the 404 is found in error
                            result = { exists: false, ok: false, error: response.error };
                        }
                        return [3 /*break*/, 5];
                    case 3:
                        error_1 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getListByTitle"));
                        sp_core_library_1.Log.error(this.LogSource, error_1);
                        result = { exists: false, ok: false, error: error_1 };
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, Promise.resolve(result)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Checks for the list existence by title and Base Template
     *  else creates the list based on the base template and the properties defined.
     * @param lstDetail : Details of the list
     */
    SPListOperations.prototype.createList = function (lstDetail) {
        return __awaiter(this, void 0, void 0, function () {
            var result, lst, createdList, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // Return the response if the object is null
                        if (!lstDetail) {
                            return [2 /*return*/, Promise.resolve({ exists: false, ok: false, error: new Error("List detail object cannot be null") })];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 6, 7, 8]);
                        // Check if the list with the same title exists
                        sp_core_library_1.Log.verbose(this.LogSource, "Check if the list with the same title exists");
                        return [4 /*yield*/, this.getListByTitle(lstDetail.title)];
                    case 2:
                        lst = _a.sent();
                        if (!(lst.exists && lst.details["BaseTemplate"] === lstDetail.baseTemplate)) return [3 /*break*/, 3];
                        sp_core_library_1.Log.verbose(this.LogSource, "List exists with same title and base template, so not created new");
                        result = lst;
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, this.spQueryPOST(this.getListMetadata(lstDetail))];
                    case 4:
                        createdList = _a.sent();
                        if (createdList.ok) {
                            result = { ok: true, exists: true, details: createdList["result"] };
                        }
                        else {
                            result = { exists: false, ok: false, error: createdList.error };
                        }
                        _a.label = 5;
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        error_2 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".createList"));
                        sp_core_library_1.Log.error(this.LogSource, error_2);
                        result = { exists: false, ok: false, error: error_2 };
                        return [3 /*break*/, 8];
                    case 7: return [2 /*return*/, Promise.resolve(result)];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method returns the items from the respective list
     * @param listTitle : Title of the list from where  data is required
     * @param query : Query to filter the results. Include '?' in the start.
     */
    SPListOperations.prototype.getListItemsByQuery = function (listTitle, query) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getListItemsBase(listTitle, query)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Method returns the items based on the next link provided
     * @param nextLink : Next link received in the previous query
     */
    SPListOperations.prototype.getListItemsByNextLink = function (nextLink) {
        return __awaiter(this, void 0, void 0, function () {
            var result, response, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, 3, 4]);
                        return [4 /*yield*/, this.spQueryGET(nextLink)];
                    case 1:
                        response = _a.sent();
                        if (response.ok) {
                            result = { ok: true, result: response.result.value, nextLink: !!response.result["odata.nextLink"] ? response.result["odata.nextLink"] : undefined };
                        }
                        else {
                            result = { ok: false, error: response.error };
                        }
                        return [3 /*break*/, 4];
                    case 2:
                        error_3 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getListItemsByNextLink"));
                        sp_core_library_1.Log.error(this.LogSource, error_3);
                        result = { ok: false, error: error_3 };
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, Promise.resolve(result)];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method returns the items from the respective list
     * @param listTitle : Title of the list from where  data is required
     * @param query : Query srtarting from '?' if any
     */
    SPListOperations.prototype.getListItemsBase = function (listTitle, query) {
        return __awaiter(this, void 0, void 0, function () {
            var result, url, response, error_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, 3, 4]);
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/Items";
                        url = SPCore_1.SPCore.isEmptyString(query) ? url : "" + url + query;
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 1:
                        response = _a.sent();
                        if (response.ok) {
                            result = { ok: true, result: response.result.value, nextLink: !!response.result["odata.nextLink"] ? response.result["odata.nextLink"] : undefined };
                        }
                        else {
                            result = { ok: false, error: response.error };
                        }
                        return [3 /*break*/, 4];
                    case 2:
                        error_4 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getListItemsBase"));
                        sp_core_library_1.Log.error(this.LogSource, error_4);
                        result = { ok: false, error: error_4 };
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, Promise.resolve(result)];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method returns the item of the respective list by Item ID
     * @param listTitle : Title of the list from where  data is required
     * @param itemID : ID of the item
     */
    SPListOperations.prototype.getListItemByID = function (listTitle, itemID) {
        return __awaiter(this, void 0, void 0, function () {
            var result, url, response, error_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = { ok: false };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/Items(" + itemID + ")";
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 2:
                        response = _a.sent();
                        if (response.ok) {
                            result = { ok: true, result: response.result };
                        }
                        else {
                            result = { ok: false, error: response.error };
                        }
                        return [3 /*break*/, 5];
                    case 3:
                        error_5 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getListItemByID"));
                        sp_core_library_1.Log.error(this.LogSource, error_5);
                        result = { ok: false, error: error_5 };
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, Promise.resolve(result)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method returns all the items based on max rows
     * @param listTitle : List title
     * @param rowCount : number of rows to return. Define 0 to get default max rows
     */
    SPListOperations.prototype.getListItems = function (listTitle, rowCount) {
        return __awaiter(this, void 0, void 0, function () {
            var query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        query = rowCount && rowCount > 0 ? "?$top=" + rowCount : undefined;
                        return [4 /*yield*/, this.getListItemsBase(listTitle, query)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Method returns the items from the respective list
     * @param libraryTitle : Title of the library from where  data is required
     * @param query : Query srtarting from '?' if any
     */
    SPListOperations.prototype.getLibraryItemsBase = function (libraryTitle, query) {
        return __awaiter(this, void 0, void 0, function () {
            var result, url, response, error_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, 3, 4]);
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + libraryTitle + "')/Files";
                        url = SPCore_1.SPCore.isEmptyString(query) ? url : "" + url + query;
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 1:
                        response = _a.sent();
                        if (response.ok) {
                            result = { ok: true, result: response.result.value, nextLink: !!response.result["odata.nextLink"] ? response.result["odata.nextLink"] : undefined };
                        }
                        else {
                            result = { ok: false, error: response.error };
                        }
                        return [3 /*break*/, 4];
                    case 2:
                        error_6 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getLibraryItemsBase"));
                        sp_core_library_1.Log.error(this.LogSource, error_6);
                        result = { ok: false, error: error_6 };
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, Promise.resolve(result)];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method returns the item of the respective list by Item ID
     * @param libraryTitle : Title of the library from where  data is required
     * @param fileId : ID of the file (do not confuse with the item)
     */
    SPListOperations.prototype.getLibraryItemByFileID = function (libraryTitle, fileId) {
        return __awaiter(this, void 0, void 0, function () {
            var result, url, response, error_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = { ok: false };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + libraryTitle + "')/Files('" + fileId + "')";
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 2:
                        response = _a.sent();
                        if (response.ok) {
                            result = { ok: true, result: response.result };
                        }
                        else {
                            result = { ok: false, error: response.error };
                        }
                        return [3 /*break*/, 5];
                    case 3:
                        error_7 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getLibraryItemByFileID"));
                        sp_core_library_1.Log.error(this.LogSource, error_7);
                        result = { ok: false, error: error_7 };
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, Promise.resolve(result)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method returns all the items based on max rows
     * @param libraryTitle : library title
     * @param rowCount : number of rows to return. Define 0 to get default max rows
     */
    SPListOperations.prototype.getLibraryItems = function (libraryTitle, rowCount) {
        return __awaiter(this, void 0, void 0, function () {
            var query;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        query = rowCount && rowCount > 0 ? "?$top=" + rowCount : undefined;
                        return [4 /*yield*/, this.getLibraryItemsBase(libraryTitle, query)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Method creates the item in the list based on the body structure to the respective list
     * @param listTitle : Title of the list where item needs to be created
     * @param body : Body of the item
     */
    SPListOperations.prototype.createListItem = function (listTitle, itemValues) {
        return __awaiter(this, void 0, void 0, function () {
            var result, listProps, body_1, response, error_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = { ok: false };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 6, 7, 8]);
                        return [4 /*yield*/, this.getListByTitle(listTitle)];
                    case 2:
                        listProps = _a.sent();
                        if (!listProps.exists) return [3 /*break*/, 4];
                        body_1 = {
                            __metadata: {
                                'type': "" + listProps.details.ListItemEntityTypeFullName
                            }
                        };
                        itemValues.forEach(function (i) {
                            body_1["" + i.fieldName] = i.fieldValue;
                        });
                        return [4 /*yield*/, this.spQueryPOST({ body: JSON.stringify(body_1), url: this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/items" })];
                    case 3:
                        response = _a.sent();
                        result = { ok: response.ok, error: response.error, result: response.result };
                        return [3 /*break*/, 5];
                    case 4:
                        result.error = listProps.error;
                        result.ok = listProps.ok;
                        _a.label = 5;
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        error_8 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".createListItem"));
                        sp_core_library_1.Log.error(this.LogSource, error_8);
                        result.error = error_8;
                        return [3 /*break*/, 8];
                    case 7: return [2 /*return*/, Promise.resolve(result)];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Creates the folder in the document library
     * @param docLib : Title of the document Library (Internal name and not the title) where folder needs to be created
     * @param folderName : Folder name
     */
    SPListOperations.prototype.createFolderInDocLib = function (docLib, folderName) {
        return __awaiter(this, void 0, void 0, function () {
            var result, response, error_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = { ok: false };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        return [4 /*yield*/, this.spQueryPOST({ body: undefined, url: this.WebUrl + "/_api/web/folders/add('" + docLib + "/" + folderName + "')" })];
                    case 2:
                        response = _a.sent();
                        result = { error: response.error, ok: response.ok, result: response.result };
                        return [3 /*break*/, 5];
                    case 3:
                        error_9 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".createFolderInDocLib"));
                        sp_core_library_1.Log.error(this.LogSource, error_9);
                        result.error = error_9;
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, Promise.resolve(result)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Method creates the folder in the list
     * @param listTitle : Title fo the list where folder needs to be created
     * @param folderName : Name of the folder needs to be created
     */
    SPListOperations.prototype.createFolderInList = function (listTitle, folderName) {
        return __awaiter(this, void 0, void 0, function () {
            var result, item, body, urlPOST, error_10;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, 3, 4]);
                        item = [
                            { fieldName: 'Title', fieldValue: "" + folderName },
                            { fieldName: 'FileLeafRef', fieldValue: "" + folderName },
                            { fieldName: 'FileSystemObjectType', fieldValue: '1' },
                            { fieldName: 'ContentTypeId', fieldValue: '0x0120' },
                        ];
                        return [4 /*yield*/, this.createListItem(listTitle, item)];
                    case 1:
                        result = _a.sent();
                        if (result.ok) {
                            body = JSON.stringify({
                                '__metadata': {
                                    'type': "" + result.result["odata.type"]
                                },
                                'Title': "" + folderName,
                                'FileLeafRef': "" + folderName
                            });
                            urlPOST = this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/items(" + result.result["Id"] + ")";
                            this.spQueryPATCH({ body: body, url: urlPOST });
                        }
                        return [3 /*break*/, 4];
                    case 2:
                        error_10 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".createFolderInList"));
                        sp_core_library_1.Log.error(this.LogSource, error_10);
                        result = { ok: false, error: error_10 };
                        return [3 /*break*/, 4];
                    case 3: return [2 /*return*/, Promise.resolve(result)];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Updates the item in the list in the current web
     * @param listTitle : Title of the list where item needs to be updated
     * @param itemId : ID of the item which needs to be updated
     * @param body : Body template of the item which needs to be updated
     */
    SPListOperations.prototype.updateListItem = function (listTitle, itemId, itemValues) {
        return __awaiter(this, void 0, void 0, function () {
            var result, listProps, body_2, response, error_11;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = { ok: false };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, 6, 7]);
                        return [4 /*yield*/, this.getListByTitle(listTitle)];
                    case 2:
                        listProps = _a.sent();
                        if (!listProps.exists) return [3 /*break*/, 4];
                        body_2 = {
                            __metadata: {
                                'type': "" + listProps.details.ListItemEntityTypeFullName
                            }
                        };
                        itemValues.forEach(function (i) {
                            body_2["" + i.fieldName] = i.fieldValue;
                        });
                        return [4 /*yield*/, this.spQueryMERGE({ body: JSON.stringify(body_2), url: this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/items(" + itemId + ")" })];
                    case 3:
                        response = _a.sent();
                        result = { ok: response.ok, error: response.error, result: response.result };
                        _a.label = 4;
                    case 4: return [3 /*break*/, 7];
                    case 5:
                        error_11 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".updateListItem"));
                        sp_core_library_1.Log.error(this.LogSource, error_11);
                        result.error = error_11;
                        return [3 /*break*/, 7];
                    case 6: return [2 /*return*/, Promise.resolve(result)];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Returns the metadata for the list creation
     * @param lstDetail
     * @param webURL
     */
    SPListOperations.prototype.getListMetadata = function (lstDetail) {
        var postListData = "{ '__metadata': { 'type': 'SP.List' }, 'BaseTemplate': " + lstDetail.baseTemplate + ",'EnableFolderCreation': " + lstDetail.allowFolder + ", 'ContentTypesEnabled': " + lstDetail.allowContentTypes + ", 'AllowContentTypes': " + lstDetail.allowContentTypes + ", 'Description': '" + lstDetail.description + "', 'Title':'" + lstDetail.title + "'}";
        var postURL = this.WebUrl + "/_api/web/lists";
        var post = {
            body: postListData,
            url: postURL
        };
        return post;
    };
    /**
     *
     * @param baseTemplate Returns the list details based on the Base Template
     */
    SPListOperations.prototype.getListsDetailsByBaseTemplateID = function (baseTemplate) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.WebUrl + "/_api/web/lists?$filter=BaseTemplate eq " + baseTemplate;
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * Returns the views associated with the list.
     * @param listTitle :Title of the list
     */
    SPListOperations.prototype.getViewsByList = function (listTitle) {
        return __awaiter(this, void 0, void 0, function () {
            var views, url, response, error_12;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        views = { ok: false };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/views/";
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 2:
                        response = _a.sent();
                        if (response.ok) {
                            views = { ok: true, views: response.result.value };
                        }
                        else {
                            views = { ok: false, error: response.error };
                        }
                        return [3 /*break*/, 5];
                    case 3:
                        error_12 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getViewsByList"));
                        sp_core_library_1.Log.error(this.LogSource, error_12);
                        views = { ok: false, error: error_12 };
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, Promise.resolve(views)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Returns the default view for the corresponding list
     * @param listTitle :Title of the list
     */
    SPListOperations.prototype.getDefaultView = function (listTitle) {
        return __awaiter(this, void 0, void 0, function () {
            var view, url, response, error_13;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        view = { ok: false };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/views?$filter=DefaultView eq true";
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 2:
                        response = _a.sent();
                        if (response.ok) {
                            view = { ok: true, view: response.result.value[0] };
                        }
                        else {
                            view = { ok: false, error: response.error };
                        }
                        return [3 /*break*/, 5];
                    case 3:
                        error_13 = _a.sent();
                        sp_core_library_1.Log.error(this.LogSource, new Error("Error occured in " + CLASS_NAME + ".getDefaultView"));
                        sp_core_library_1.Log.error(this.LogSource, error_13);
                        view = { ok: false, error: error_13 };
                        return [3 /*break*/, 5];
                    case 4: return [2 /*return*/, Promise.resolve(view)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Returns all the content types associated with the list
     * @param listTitle : Title of the list
     */
    SPListOperations.prototype.getContentTypesByList = function (listTitle) {
        return __awaiter(this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.WebUrl + "/_api/web/lists/getByTitle('" + listTitle + "')/contentTypes/";
                        return [4 /*yield*/, this.spQueryGET(url)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return SPListOperations;
}(SPBase_1.SPBase));
exports.SPListOperations = SPListOperations;
